#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire200eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight2004xi    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight2004xi = {
                1:'-100x-112y-130z',
                2:'-102x-26y-169z',
                3:'-103x-131y-109z',
                4:'-103x-170y-7z',
                5:'-107x-108y-129z',
                6:'-10x-35y-196z',
                7:'-10x-65y-188z',
                8:'-111x-126y-107z',
                9:'-112x-165y-5z',
                10:'-113x-103y-127z',
                11:'-118x-121y-106z',
                12:'-120x-98y-126z',
                13:'-121x-159y-3z',
                14:'-125x-115y-104z',
                15:'-126x-92y-124z',
                16:'-129x-152y-1z',
                17:'-12x-37y-196z',
                18:'-131x-86y-123z',
                19:'-132x-109y-102z',
                20:'-137x-145y0z',
                21:'-137x-80y-121z',
                22:'-138x-103y-101z',
                23:'-13x-133y-147z',
                24:'-142x-73y-119z',
                25:'-144x-96y-99z',
                26:'-146x-66y-118z',
                27:'-14x-153y-127z',
                28:'-14x-197y-25z',
                29:'-14x-67y-187z',
                30:'-150x-88y-97z',
                31:'-151x-59y-116z',
                32:'-155x-51y-115z',
                33:'-155x-81y-95z',
                34:'-158x-43y-113z',
                35:'-15x-38y-195z',
                36:'-160x-73y-94z',
                37:'-162x-35y-111z',
                38:'-164x-26y-110z',
                39:'-164x-65y-92z',
                40:'-167x-18y-108z',
                41:'-168x-57y-90z',
                42:'-172x-48y-88z',
                43:'-175x-39y-86z',
                44:'-18x-39y-195z',
                45:'-18x-68y-187z',
                46:'-1x-29y-197z',
                47:'-20x-134y-146z',
                48:'-21x-39y-194z',
                49:'-22x-153y-125z',
                50:'-22x-68y-186z',
                51:'-24x-40y-194z',
                52:'-25x-196y-23z',
                53:'-27x-134y-145z',
                54:'-27x-40y-193z',
                55:'-27x-69y-185z',
                56:'-30x-153y-124z',
                57:'-30x-40y-193z',
                58:'-31x-69y-184z',
                59:'-33x-40y-192z',
                60:'-35x-134y-143z',
                61:'-35x-195y-21z',
                62:'-35x-69y-184z',
                63:'-37x-40y-192z',
                64:'-39x-153y-122z',
                65:'-3x-31y-197z',
                66:'-40x-39y-191z',
                67:'-40x-68y-183z',
                68:'-42x-133y-142z',
                69:'-44x-38y-191z',
                70:'-45x-193y-19z',
                71:'-45x-68y-182z',
                72:'-47x-151y-121z',
                73:'-47x-37y-190z',
                74:'-49x-67y-181z',
                75:'-4x-197y-27z',
                76:'-50x-132y-141z',
                77:'-51x-35y-189z',
                78:'-54x-34y-189z',
                79:'-54x-65y-180z',
                80:'-55x-150y-119z',
                81:'-55x-191y-17z',
                82:'-57x-131y-139z',
                83:'-57x-32y-188z',
                84:'-58x-64y-180z',
                85:'-5x-32y-197z',
                86:'-5x-94y-284z',
                87:'-61x-30y-188z',
                88:'-63x-62y-179z',
                89:'-64x-129y-138z',
                90:'-64x-148y-117z',
                91:'-64x-27y-187z',
                92:'-65x-188y-15z',
                93:'-67x-24y-186z',
                94:'-67x-60y-178z',
                95:'-6x-132y-149z',
                96:'-6x-152y-128z',
                97:'-70x-21y-185z',
                98:'-72x-126y-136z',
                99:'-72x-145y-116z',
                100:'-72x-57y-177z',
                101:'-73x-18y-185z',
                102:'-75x-184y-13z',
                103:'-76x-14y-184z',
                104:'-76x-54y-176z',
                105:'-78x-11y-183z',
                106:'-79x-123y-135z',
                107:'-7x-34y-196z',
                108:'-7x-64y-189z',
                109:'-80x-142y-114z',
                110:'-80x-51y-175z',
                111:'-80x-7y-182z',
                112:'-85x-180y-11z',
                113:'-85x-48y-174z',
                114:'-86x-120y-133z',
                115:'-88x-139y-112z',
                116:'-89x-44y-173z',
                117:'-92x-40y-172z',
                118:'-93x-117y-132z',
                119:'-94x-175y-9z',
                120:'-96x-135y-111z',
                121:'-96x-36y-171z',
                122:'-99x-31y-170z',
                123:'0x-131y-150z',
                124:'0x-1y-199z',
                125:'0x-25y-198z',
                126:'0x-27y-198z'}
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire200eight4xi" usage = "target function for charge200eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire200eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE200EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE200EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE200EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE200EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE200EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight2004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE200EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE200EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE200EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight2004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight2004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE200EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE200EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE200EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire200eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  